/*
 * Activiti Modeler component part of the Activiti project
 * Copyright 2005-2014 Alfresco Software, Ltd. All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

/*
 * Task listeners
 */

var KisBpmTaskListenersCtrl = [ '$scope', '$modal', '$timeout', '$translate', function($scope, $modal, $timeout, $translate) {
    if ($scope.property.value !== undefined && $scope.property.value !== null
        && $scope.property.value.taskListeners !== undefined
        && $scope.property.value.taskListeners !== null) {

        if ($scope.property.value.taskListeners.constructor == String)
        {
            $scope.taskListeners = JSON.parse($scope.property.value.taskListeners);
        }
        else
        {
            // Note that we clone the json object rather then setting it directly,
            // this to cope with the fact that the user can click the cancel button and no changes should have happened
            $scope.taskListeners = angular.copy($scope.property.value.taskListeners);
        }

        for (var i = 0; i < $scope.taskListeners.length; i++)
        {
            var executionListener = $scope.taskListeners[i];
            if(executionListener.event !== undefined && executionListener.event !== ''){
                executionListener.eventType = executionListener.event;
            }
            if (executionListener.delegateExpression !== undefined && executionListener.delegateExpression !== '')
            {
                executionListener.methodName = executionListener.delegateExpression;
            }
        }
    } else {
        $scope.taskListeners = [];
    }

    var getQueryString = function(name)
    {
        var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
        var r = window.location.search.substr(1).match(reg);
        if(r!=null)return  unescape(r[2]); return null;
    }

    $scope.showCustom= function () {

        if (jQuery('#win1').data('kendoWindow')) {
            jQuery('#win1').data('kendoWindow').open()
        } else {
            jQuery('#win1').kendoWindow({
                width: 600,
                height: 500,
                modal: true,
                title: "任务监听器",
            }).data('kendoWindow').center();

            var dataSource = new kendo.data.DataSource({
                transport:{
                    read:function(options){
                        var data = $scope.query();
                        if(!data){
                            data = []
                        }
                        options.success(data);
                    },
                    create: function(options) {
                        options.success(options.data.models)
                    },
                    update: function(options) {
                        options.success(options.data.models)
                    },
                    destroy: function(options) {
                        options.success(options.data.models)
                    }
                },
                batch: true,
                schema: {
                    model: {
                        id: "eventType",
                        fields: {
                            "eventType": {},
                            "methodName": {}
                        }
                    }
                }
            });

            var crudServiceBaseUrl = _basePath +'/wfl/approve/candidate/rule',
                comboboxDataSource = {

                    data:[
                        {
                            code: 'create',
                            description: 'create'
                        },
                        {
                            code: 'complete',
                            description: 'complete'
                        },
                        {
                            code: 'assignment',
                            description: 'assignment'
                        },
                        {
                            code: 'delete',
                            description: 'delete'
                        }
                    ]};

            var grid = jQuery('#win1').find("#grid1").kendoGrid({
                navigatable: true,
                dataSource:dataSource,
                height: 430,
                scrollable: true,
                selectable:'rowbox,multiple',
                columns: [
                    {
                        field: "eventType",
                        title: '事件类型',
                        width: 150,
                        template: function (dataItem) {
                            var v = dataItem.eventType;
                            if(comboboxDataSource.data.length){
                                jQuery.each(comboboxDataSource.data, function (i, n) {
                                    if ((n.code || '').toLowerCase() == (v || '').toLowerCase()) {
                                        v = n.description;
                                        return false;
                                    }
                                })
                                dataItem.set("description",v);
                            }else{
                                v = dataItem.description;
                            }

                            return v || '';
                        },
                        editor: function (container, options) {
                            jQuery('<input required name="' + options.field + '"/>')
                                .appendTo(container)
                                .kendoComboBox({
                                    dataTextField: "description",
                                    dataValueField: "code",
                                    dataSource: comboboxDataSource,
                                    valuePrimitive: true,
                                    change:function(e){
                                        /*options.model.set("eventType",undefined);*/
                                    }
                                });
                        }
                    },
                    {
                        field: "methodName",
                        title: '代理表达式',
                        template: function (dataItem) {
                            return dataItem['methodName'] || ''
                        },
                        width: 150,
                        editor: function (container, options) {
                            lov = "LOV_HLS_VARIABLE";
                            jQuery('<input required name="' + options.field + '"/>')
                                .appendTo(container)
                                .kendoLov({
                                    contextPath:_basePath,
                                    locale:_locale,
                                    code:lov,
                                    model:options.model,
                                    textField:'methodName',
                                    query:function(e){
                                        var key = getQueryString("key");
                                        e.param.workflowCode = key;
                                    },
                                    select:function(e){
                                        var data = e.item;
                                        options.model.set("methodName",data.methodName);
                                        options.model.set("description",data.description);
                                    }
                                });
                        }
                    }],
                editable: true
            }).data("kendoGrid");

            jQuery('#win1').data('kendoWindow').open()
        }

    };

    //定义查询变量
    //点击查询按钮
    $scope.query = function(){
        return $scope.taskListeners;
    }

    $scope.save = function() {
        debugger;
        if ($scope.taskListeners.length > 0) {
            $scope.property.value = {};
            $scope.property.value.taskListeners = $scope.taskListeners;
            $scope.property.value.taskListeners = handleExecutionInput($scope);
        } else {
            $scope.property.value = null;
        }
        $scope.updatePropertyInModel($scope.property);
        $scope.close();


    };

    $scope.queryCondition = function(uid){
        if(uid ){
            var gridData =jQuery('#grid1').data('kendoGrid');
            var item = gridData.dataSource.getByUid(uid)
            return item.rules;
        }
        return [];
    }

    $scope.saveCondition = function(uid,data){
        var a = jQuery('#grid1').data('kendoGrid');
        var item = a.dataSource.getByUid(uid);
        item.rules = data;
    }
    $scope.close = function() {
        $scope.property.mode = 'read';
        jQuery('#win1').data('kendoWindow').close();
    };

    var handleExecutionInput = function($scope) {
        var taskListeners = [];
        if ($scope.taskListeners)
        {
            for (var i = 0; i < $scope.taskListeners.length; i++)
            {
                taskListeners[i] = {
                    event:'',
                    implementation : '',
                    className : '',
                    expression: '',
                    delegateExpression: ''
                };
                taskListeners[i].event = $scope.taskListeners[i].eventType;
                taskListeners[i].delegateExpression = $scope.taskListeners[i].methodName;

            }
        }
        return taskListeners;
    };

}];